tde
===

Matlab implementation of triangular dislocation elements (TDEs) in a homogeneous elastic half space from meade@fas.harvard.edu

Dislocation theory is a ubiquitous tool used to model the quasi-static response of the Earth's crust to faulting and earthquakes. The Matlab™ codes in this zip file calculate the displacements, strains, and stresses due to uniform slip on a triangular dislocation element in a homogeneous elastic half space. A description of the algorithms and a perspective on the history of the development of this theory can be found in Meade (2007), Algorithms for the calculation of exact displacements, strains, and stresses for triangular dislocation elements in a uniform elastic half space, Computers & Geosciences.

There are also two Python TDE implementations:
- Richard Styron (richard@earth-analysis.com) has produced a python version! (https://github.com/cossatot/tri_dislocations_python)
- **HIGHLY RECOMMENDED IN 2021:** [`cutde`](https://github.com/tbenthompson/cutde) has parallelized and optionally GPU accelerated implementations of the TDE method from Nikkhoo and Walter 2015. 
